<template>
    <Head title="Товарные категории" />
    <div class="g-titlebar">
        <h1>Товарные категории</h1>
        <Link href="/product_categories/create/" class="g-button outlined"> Создать товарную категорию </Link>
    </div>
    <div class="b-producttree">
        <div class="b-producttree-header">
            <div class="b-producttree-row">
                <div class="b-producttree-cell for_title">Название</div>
                <div class="b-producttree-cell for_assignee">Менеджеры по Продажам</div>
                <div class="b-producttree-cell for_actions"></div>
            </div>
        </div>
        <el-tree :data="productCategories" node-key="id" draggable default-expand-all @node-drop="handleDrop">
            <template #default="{ data }">
                <div class="b-producttree-row">
                    <div class="b-producttree-cell for_title">
                        <Link :href="`/product_types/?category=${data.id}`">
                            {{ data.title }}
                        </Link>
                    </div>
                    <div class="b-producttree-cell for_assignee">
                        <Link :href="`/users/${data.lead_sales_id}/`" v-if="data.lead_sales_id">
                            {{ data.lead_sales_name }}
                        </Link>
                    </div>
                    <div class="b-producttree-cell for_actions">
                        <Link :href="`/product_categories/${data.id}/edit/`" title="Редактировать" class="g-actionicon">
                            <font-awesome-icon icon="pen-to-square" />
                        </Link>
                        <a @click="deleteProductCategory(data.id, data.title)" title="Удалить" class="g-actionicon">
                            <font-awesome-icon icon="trash" />
                        </a>
                    </div>
                </div>
            </template>
        </el-tree>
    </div>
</template>

<script>
import { router } from "@inertiajs/vue3";
export default {
    props: {
        productCategories: Object,
        stageNames: Object,
        initialFilter: Object,
    },
    data() {
        return {
            filter: {
                q: this.initialFilter?.q || "",
                loading: false,
            },
        };
    },
    methods: {
        handleDrop(draggingNode, dropNode, dropType) {
            // after / before / inner
            router.post(`/product_categories/${draggingNode.data.id}/move`, {
                target: dropNode.data.id,
                relation: dropType,
            });
        },
        deleteProductCategory(name, title) {
            if (!confirm(`Вы действительно хотите удалить товарную категорию «${title}»?`)) return;
            router.delete(`/product_categories/${name}/`);
        },
    },
};
</script>

<style lang="scss">
$iconWidth: 18px;
.b-producttree {
    &-header {
        font-weight: bold;
        border-bottom: 1px var(--border) solid;
        .for_title {
            padding-left: $iconWidth + 6px;
            width: 400px;
        }
    }
    &-row {
        display: flex;
        flex-grow: 1;
    }
    &-cell {
        font-size: 1rem;
        color: var(--black);
        padding: 10px 0;
        &.for_title {
            width: 400px;
            .el-tree-node__children & {
                width: calc(400px - $iconWidth);
                .el-tree-node__children & {
                    width: calc(400px - 2 * $iconWidth);
                    .el-tree-node__children & {
                        width: calc(400px - 3 * $iconWidth);
                        .el-tree-node__children & {
                            width: calc(400px - 4 * $iconWidth);
                        }
                    }
                }
            }
        }
        &.for_actions {
            margin-left: auto;
        }
        &.for_assignee {
            min-width: 200px;
        }
    }
    .el-tree-node__expand-icon {
        // Размеры этой иконки влияют на положение drop-indicator, поэтому должно прилегать к верху и низу
        padding: 14px 6px !important;
    }
    .el-tree-node__content {
        height: auto;
        border-bottom: 1px var(--border) solid;
    }
    .el-tree__drop-indicator {
        height: 3px !important;
    }
}
</style>
